.title "tetet"			@ T E T
.arm				@ E
.include "macro.mac"		@ T

	@ showtblrot 0..rotdiv, rotdiv/2=45 deg.
	@ tbl[] is displayed as a rotated (5-85 deg)
	@ rectangle depending on weight/tiles put in it.
rotdiv		=32

	@ game timer resolution is 1/16 per sec
	@ tile fall speed is game_speed/16 per sec
game_speed	=6
	@ menu scroll speed
menu_speed	=3	@ N/16 sec

	@ tbl size - do not change!!!
	@ game table -playfield- size is 17 by 17 blocks
	@ including drop zones (3x3 blocks)
	@ table is stored as tblsiz x .word
tblsiz		=17
	@ max weight per side stored in 'mw'
	@ calculated for 'tblsiz'
itmp=(tblsiz-6)-1	@ 543210  max weight of one half
mw=0			@ 43210.  of tbl[] is calculated
.rept itmp		@ 3210..
 i=itmp			@ 210...
 .rept itmp		@ 10....
  mw=mw+i		@ 0.....
  i=i-1
 .endr
 itmp=itmp-1
.endr
	@ dropzone y-ofs, x-shift values on tbl[]
tilepos1_shift	=5
tilepos1_ofs	=4
tilepos2_shift	=1
tilepos2_ofs	=0x14
	@ dropzone masks on tbl[]
gap_top		=	  0b11100000
gap_right	=	  0b00010000
tbl_line_mask	=0b01111111111100000
	@ drop directions
top_to_bottom	=4	@ sizeof .word
left_to_right	=1	@ shift value

	@ textured or 1-color board
texboard	=1
	@ mandelbrot fractal or 'backgroung.img' as background
 	@ image is 16bpp raw image 800 x 480 pixels
mandelback	=1

	@ sound effect length in bytes
	@ dsp setfragment must be less than file size to play
 	@ immediately
sound_buf_size	=4600

	@ debug info displayed
debug		=0

.text
.globl _start
_start:

@ initialize framebuffer device "/dev/fb0"
@ get screen info
@ setup double buffered graphics
@ r0=fbp on return
 bl fbinit
 cmn r0,#0
bne fb_done
 exit 1
fb_done:

@ 1:load background image OR generate mandelbrot fractal
@ 2:copy background image to framebuffer pages 0,1
 bl loadbg

@ open linux events for keypad and gpio_keys
 bl keyb_init

@ prints out help/pause/main menu help to blit_txt[]
 bl prep_txt

@ open and load sound effect file
 ldr r0,snd_effect_ofs
 mov r1,#o_rd
  invoke sys_open
 subs r4,r0,#0
bmi 11f
 ldr r1,sound_buf_ofs
 movw r2,sound_buf_size
  invoke sys_read
 mov r0,r4
  invoke sys_close
11:

@ open dsp device "/dev/dsp"
 ldr r0,dev_dsp_ofs
 mov r1,#o_wr
 mov r4,r0
  invoke sys_open
 cmp r0,#0
@ store device handle on first 4 bytes of file name
@  if it was opened successfuly
  strpl r0,[r4]
bmi nodspdev

@ dsp initialization
@ reset first then set fragment
sio_out		=0b11 << 30
sio_tmp 	=sio_out | (4 << 16) | 'P' << 8
dsp_reset	='P' << 8
 mov r1,#dsp_reset
 mov r4,r0
  invoke sys_ioctl

@ ioctl dspdev to set fragment size * fragment number
@ to smaller value than sound effect file size
dsp_setfrag 	=sio_tmp | 0xa
 movw r3,10		@ fragment buffer size 2^n
 movw r1,dsp_setfrag & 0xffff
 movt r3,1		@ fragment buffer number
@ r3= 1 << 16 | 10
 movt r1,dsp_setfrag >> 16
 push {r3}
  mov r0,r4
  mov r2,sp
  invoke sys_ioctl
 add sp,#4
nodspdev:

@
@ G A M E   L O O P
@
@ get initial 1/16 timer value
@ r12 holds timer value over the game
 bl get_ticks
 add r12,r0,#menu_speed

menuloop:
 bl show_menu

@ display help message if needed
 bl fade_in

menuloop1:
 bl get_ticks
 cmp r0,r12
  addge r12,r0,#menu_speed
  bge menuloop

@ still waiting for the next 'tick'
@ screen update is not needed
@ let's handle input events

 bl getkey

 ldr r2,menu_selected_ofs

 cmp r0,#game_b
beq menukeypress
 ldm r2, {r3-r5}
@ r3=active menu #
@ r4=shift position
@ r5=shift direction
 cmp r0,#key_up
  inc r3
bne 1f
  cmp r3,#menu_items
   movge r3,#0
  b 2f
1:
 cmp r0,#key_down
bne menuloop1
  subs r3,#2
   movmi r3,#(menu_items-1)

2:	@ menu # is between 0..(menu_items-1)
 clr r4
 mov r5,#1
 stm r2!, {r3-r5}

fade_out_in_menu:
@ tbl[] holds the last title bitmap
@ r2=menu[]
 mov r9,#menu_entry_siz 
 mov r10,#9		@ 5*2 lines to fade out
 ldr r5,tbl_ofs
 mul r3,r9
 movw r6,#tbl_line_mask
 add r5,#(5*4)
 ldr r9,[r2,r3]		@ read next img ofs

fade_out_tbl:
 bl get_ticks
 cmp r0,r12
blt fade_out_tbl
 inc r12

 bl blit_tbl		@ show it
 rsb r0,r10,#(rotdiv/2+9)
 bl showtblrot
 bl fb_flip

 tst r10,#1	@ every 2 cycle
 beq 1f
  push {r5}
   mov r4,r10, lsr #1
  2:	ldm r5,{r0,r1}
	add r5,#4
	bic r0,r6
	and r1,r6
	orr r0,r1
	subs r4,#1
	str r0,[r5,#(-4)]
	bpl 2b
  pop {r5}
1:
 subs r10,#1
bpl fade_out_tbl
@ r10=(-1)

 add r9,#(4*4)
@ r9=last line of menu title bitmap
@ tbl[] is clear
 mov r10,#9
 add r5,#(3*4)
@ r5=tbl[8*4]

fade_in_tbl:
 bl get_ticks
 cmp r0,r12
blt fade_in_tbl
 inc r12

 bl blit_tbl		@ show it
 add r0,r10,#(rotdiv/2)
 bl showtblrot
 bl fb_flip

 tst r10,#1	@ every 2 cycle
beq 1f
 mov r4,#4
 push {r5}
2:
   ldm r5, {r0,r1}
   sub r5,#4
   and r0,r6
   bic r1,r6
   orr r0,r1
   subs r4,#1
   str r0,[r5,#8]
   bne 2b
  ldr r0,[r9],#(-4)	@ insert new line
  and r0,r6,r0, lsl #5
  orr r0,r1
  str r0,[r5,#4]
 pop {r5}
1:
 subs r10,#1
bpl fade_in_tbl
b menuloop1

@
@ came here from main menu because
@ 'game_b' key was pressed
menukeypress:
@ r2=active_menu[]
@  [0]=active menu #
@  [4]=scroll position
@  [8]=scroll direction
 ldr r0,[r2],#12
@ r2=menu[]
 mov r1,#menu_entry_siz
 mul r0,r1
 add r2,#8
@  [0]=bitmap ofs
@  [4]=scroll width
@  [8]=branch address
 ldr r1,[r2,r0]
 cmp r1,#0
  movne pc,r1
b menuloop

@ 'fade_in' procedure
@ shows help message depending on a counter's value
@ decides automatically what message to show
.include "fade.inc"

@
@ menu entry "new game"
me_newgame:
 bl fade_clr

 ldr r2,active_tile_ofs
 mov r0,#rotdiv/2
 str r0,[r2,#(balance_cur-active_tile)]
 str r0,[r2,#(balance-active_tile)]

@ clr tbl[]
 ldr r5,tbl_ofs
 movw r6,#tbl_line_mask
 mov r2,#(tblsiz-2)
 add r5,#((tblsiz-2)*4)
1:		@ clear tbl[]
 ldr r0,[r5]
 cmp r2,#7
 sub r5,#4
  orreq r6,#0b01110
 cmp r2,#4
  bicne r0,r6
  andeq r6,#0b11100000
 subs r2,#1
 str r0,[r5,#4]
bne 1b

@ r2=0, r5=tbl[]
@ set score to 0
@ str r2,[r5,#(score-tbl)]

game_addtile:
 bl add_new_tile

game_showloop:
 ldr r2,active_tile_ofs
@ load active tile
@ r0=shape, r4=x shift, r5=y ofs
 ldm r2, {r0,r4,r5}

 ldm r5, {r1-r3}
 push {r1-r3,r5}	@ save tbl[] lines under tile

 bl col_tst		@ put tile on tbl[]

 bl blit_tbl		@ show tbl

 ldr r2,active_tile_ofs
 ldr r0,[r2,#(balance_cur-active_tile)]
 bl showtblrot

 bl fb_flip

 pop {r1-r3,r5}		@ restore tbl[] lines under tile
 stm r5, {r1-r3}

 bl fade_in

game_wait:
 bl get_ticks
 cmp r0,r12
ble game_no_move_readkey
 add r12,#game_speed	@ update timer

 ldr r2,active_tile_ofs
 mov r3,#1
 ldr r0,[r2,#(balance_cur-active_tile)]
 ldr r1,[r2,#(balance-active_tile)]
  cmp r0,r1
 ldr r7,[r2,#(direction-active_tile)]
   addlt r0,r3
   subgt r0,r3
   strne r0,[r2,#(balance_cur-active_tile)]

 ldm r2, {r0,r4,r5}	@ load tile data

 cmp r7,#top_to_bottom	@ move tile according
  addne r4,r7		@  to direction
  addeq r5,r7

 ldm r5, {r6,r10,r11}	@ save tbl[] lines under tile

 bl col_tst
 cmp r8,#0
bne 1f
@ no collision
@ clear 'leave_block' flag
 str r8,[r2,#(leave_block-active_tile)]
 stm r2, {r0,r4,r5}	@ update tile if no collision
 stm r5, {r6,r10,r11}   @ restore tbl[] lines
b game_showloop

1:
@ tile collides with tbl[] blocks
 ldr r1,[r2,#(leave_block-active_tile)]
 cmp r1,r8
@ if ('leave_block' flag is not set) 
@  then let block move for a clock tick
  strne r8,[r2,#(leave_block-active_tile)]
  bne game_showloop

@ if ('leave_block' flag was set)
@  and (+1 clock tick has passed)
@ then load last good tile position
 ldm r2, {r0,r4,r5}
@ and fix it on tbl[]
 bl col_tst

 bl check_dropzones
 cmp r0,#0
bne game_over

 bl chk_full
 cmp r7,#0
@ if (r7=0)
@  then no line was removed
beq 111f
@ play sound
@  if at least a line was removed
 ldr r6,dev_dsp_ofs
 movw r2,sound_buf_size
 ldr r1,sound_buf_ofs
 mov r7,#sys_write
 ldr r0,[r6]
 cmp r0,#0x3f
@ invoke sys_write if dspdev was
@  opened successfully
  swilt 0
111:

 bl calc_balance
b game_addtile

dev_dsp_ofs:		.word dev_dsp
snd_effect_ofs:		.word snd_effect
sound_buf_ofs:		.word sound_buf

game_no_move_readkey:	@ check keypress
 bl getkey
 subs r2,r0,#0
beq game_wait

@ a key was pressed

 ldr r3,active_tile_ofs

 cmp r2,#game_x		@ pause/quit game
  beq pause_game

@ load tile data
 ldm r3,{r0,r4,r5}

 cmp r2,#game_y		@ rotate tile
  moveq r0,r0, ror #2
  beq keys_done

 ldr r6,[r3,#(direction-active_tile)]

 cmp r2,#key_down	@ drop tile
bne 1f

2:			@ drop tile loop
 cmp r6,#left_to_right
  addne r5,r6
  addeq r4,r6
 ldm r5, {r1,r2,r7}
 bl col_tst
 cmp r8,#0
  stmeq r5, {r1,r2,r7}
  stmeq r3, {r0,r4,r5}
  beq 2b
b game_showloop

1:
 eor r6,#(top_to_bottom | left_to_right)

 cmp r2,#key_right
bne 3f
 cmp r6,#left_to_right
  addeq r4,r6
  subne r5,r6
b keys_done

3:
 cmp r2,#key_left
@bne 4f
bne game_wait
 cmp r6,#top_to_bottom
  addeq r5,r6
  subne r4,r6
b keys_done

@4:
@bne game_wait

keys_done:
 ldm r5, {r1,r2,r6}

 bl col_tst
 cmp r8,#0
  stmeq r5, {r1,r2,r6}
  stmeq r3, {r0,r4,r5}
b game_showloop

confuse_tbl:
 ldr r2,tbl_ofs
 movw r1,#0b1010101010100000
 mov r3,#(tblsiz-6)
 add r2,#(5*4)
 movt r1,#0b0101010101000000
1:
 ldr r0,[r2]
 mov r1,r1, ror #16
 eor r0,r1
 str r0,[r2],#4
 subs r3,#1
bne 1b
mov pc,lr

pause_game:
 bl fade_clr

 bl confuse_tbl

 bl get_ticks
 add r12,r0,#menu_speed

 ldr r10,active_tile_ofs
 mov r9,#1
 ldr r11,[r10,#(balance_cur-active_tile)]
 cmp r11,#(rotdiv/2)
  rsbgt r9,#0

1:
 bl get_ticks
 cmp r0,r12
blt 2f
 add r12,r0,#menu_speed

 bl fade_in

 bl blit_tbl
 mov r0,r11
 bl showtblrot
 bl fb_flip

 add r11,r9
 cmp r11,#rotdiv
  subhi r11,r9, lsl #1
  rsbhi r9,#0

2:
 bl getkey
 cmp r0,#game_x
  beq exit_game
 cmp r0,#game_y
bne 1b

 str r11,[r10,#(balance_cur-active_tile)]

 bl confuse_tbl

 bl get_ticks
 add r12,r0,#0

 bl fade_clr

@ clr r0		@ 'new game'
@ ldr r8,menu_selected_ofs
@ mov r1,r0
@ add r2,r1,#1
@ stm r8, {r0-r2}
b game_showloop

game_over:
 bl fade_clr

 ldr r2,tbl_ofs
 mov r9,#(tblsiz-6)
 ldr r7,active_tile_ofs
 movw r4,#tbl_line_mask
 ldr r8,[r7,#(balance_cur-active_tile)]
 mov r6,#1
 add r2,#(10*4)

 bl get_ticks
 add r12,r0,#1

1:
 bl get_ticks
 cmp r0,r12
blt 1b
 inc r12

 mov r3,#(tblsiz-6-5)	@ last 6 lines
 push {r2}
2:
 ldr r0,[r2]
 eor r6,#1
 and r1,r0,r4
 bic r0,r4
 tst r6,#1
  andeq r1,r4,r1, lsl #1
  andne r1,r4,r1, lsr #1
 orr r0,r1
 subs r3,#1
 str r0,[r2],#4
bne 2b

 bl blit_tbl
 cmp r8,#(rotdiv/2)
  addlt r8,#1
  subgt r8,#1
 mov r0,r8
 bl showtblrot
 bl fb_flip

 subs r9,#1
 pop {r2}
bne 1b

4:
 bl get_ticks
 cmp r0,r12
blt 4b
 add r12,#menu_speed

 bl blit_tbl
 cmp r8,#(rotdiv/2)
  beq 3f
  addlt r8,#1
  subgt r8,#1
 mov r0,r8
 bl showtblrot
 bl fb_flip
b 4b

3:
@ r8=rotdiv/2
 ldr r7,active_tile_ofs
 clr r3		@ 'new game'
 ldr r2,menu_selected_ofs
 mov r4,r3
 str r8,[r7,#(balance_cur-active_tile)]
 mov r5,#1
 stm r2!, {r3-r5}
@ r2=menu[]
b fade_out_in_menu

exit_game:	@ game_x pressed
 bl keyb_close
 bl fbclose
exit 0

getkey:
 push {r1-r3,r7,lr}

 mov r2,#evdata_len
 ldr r1,evdata_ofs

 clr r0
 mov r3,r2, lsr #2
getkey_clr:
 subs r3,#4
 str r0, [r1,r3]
bpl getkey_clr

 ldr r3,fd_tbl_ofs
 ldr r0,[r3],#4
 invoke sys_read	@ read "keypad"
 cmp r0,#ev_size
bge getkey_rd_ok

 ldr r0,[r3]
 invoke sys_read	@ read "gpio-keys"
 cmp r0,#ev_size
 clr r0
  poplt {r1-r3,r7,pc}

getkey_rd_ok:
@ r1=evdata[]
 ldrh r2,[r1,#ev_type]
 ldr r3,[r1,#ev_value]
 ldrh r0,[r1,#ev_code]

 cmp r2,#ev_key
  cmpeq r3,#ev_press
    popeq {r1-r3,r7,pc}
 clr r0
pop {r1-r3,r7,pc}

menu_selected_ofs:	.word menu_selected
show_menu:
 push {lr}
 ldr r2,menu_selected_ofs
 movw r6,#tbl_line_mask
 ldm r2!, {r0,r4,r7}
@ r0=active menu #
@ r4=shift position
@ r7=shift position direction
@ r2=menu[]
 mov r3,#5
 mov r1,#menu_entry_siz
 ldr r5,tbl_ofs
 mul r0,r1
 add r2,r0
 add r5,r5,r3, lsl #2	@ add #(5*4)
@ r2[]	=active menu entry
@   [0]	=title bitmap offset
@   [4] =scroll width
@   [8] =branch offset if selected
 ldm r2, {r0,r8}

1:
 ldr r1,[r0]
 add r0,#4
 ldr r2,[r5]
 mov r1,r1, lsr r4
 bic r2,r6
 and r1,r6,r1, lsl #5
 add r5,#4
 orr r1,r2
 subs r3,#1
 str r1,[r5,#(-4)]
bne 1b

 ldr r2,menu_selected_ofs
 add r4,r7
 cmp r4,r8
 add r2,#4	@ skip active menu #
  subhi r4,r7, asl #1
  rsbhi r7,#0
 stm r2, {r4,r7}

 bl blit_tbl
 mov r0,#(rotdiv/2)
 bl showtblrot
 bl fb_flip
pop {pc}

bal_mult:	.word ((rotdiv/2) << 16) / mw
calc_balance:
 ldr r2,tbl_ofs
 clr r3		@ bit weight
 mov r5,#(tblsiz-6)
 clr r1		@ total weight
 add r2,#(5*4)
1:
 ldr r0,[r2],#4		@	  #   #
 mov r7,r3		@ #########...#####
 mov r0,r0, lsr #5	@ #a9876543210.   #
 mov r4,#(tblsiz-6)	@ #98765432101.   #
2:			@ #87654321012.   #
 movs r0,r0, rrx	@ #76543210123#####
  addcs r1,r7		@ #65432101234#
 subs r4,#1		@ #54321012345#
 dec r7			@ #43210123456#
bne 2b			@ #32101234567#
 subs r5,#1		@ #21012345678#
 inc r3			@ #10123456789#
bne 1b			@ #0123456789a#
			@ #############
 ldr r0,bal_mult
 mul r0,r1
 ldr r2,active_tile_ofs
 mov r1,r0, asr #16
 rsb r1,#(rotdiv/2)
 str r1,[r2,#(balance-active_tile)]
mov pc,lr

col_tst:
@ collision test between tile and tbl[]
@ r0,r4,r5 <> tbl[]
 push {r0-r3,r6,r7,lr}

@ 'unpack' tile stored in r0
@ tile bits: 210
@	     3x7
@	     456
@ stored as 0b76543210765432107654321076543210

@ prepare mask value
 movw r1,#0b101000010101000

@ 210 bits were in the right bit-order so copy it to r2
@          .............210
 and r2,r0,#0b111

@ mask out unneeded bits from r1
@ 3x7 and 456 will remain in r0
@           6.4....7.5.3...
 and r0,r1

 movw r1,#0b10000010001
@       6.4....7.5.3...
@   6.4....7.5.3...
@  ..7.5.3...
@ copy bits into position by multiplying with r1
@ =.67456347.5.?.5.3...
 mul r0,r1

 mov r1,#0b111

@ mask out unneeded bits
@ and leave only 456 and 3.7
@       ...4563.7...........
 and r0,#0b11110100000000000
 mov r2,r2, lsl r4

@   .....................3.7
 and r1,r1,r0, lsr #11

@    ....................456
 mov r0,r0, lsr #14

@ set bit at the center of tile in r1
@   ..................4563x7
 orr r1,#0b10

 mov r0,r0, lsl r4

@ load 3 lines of tbl[] for collision test
@
@ r5 = tbl[y_ofs]
 ldm r5, {r3,r6,r7}
 mov r1,r1, lsl r4

@ tile is unpacked to r2,r1,r0
@ all 3 bit lines are shifted left by r4, 'x_shift'
@ r2= .....210 << r4
@ r1= .....3x7 << r4
@ r0= .....456 << r4

 mvn r8,#0
  tst r3,r2	@ test 1st line
 orr r3,r2
  tsteq r6,r1	@ test 2nd line if 1st was okay
 orr r6,r1
  tsteq r7,r0	@ test 3rd line if 1st and 2nd were okay
 orr r7,r0
  moveq r8,#0	@ set collison flag if tile does not collide
		@  and store back tbl lines
  stmeq r5, {r3,r6,r7}
pop {r0-r3,r6,r7,pc}

.include "island.inc"	@ proc chk_full

check_dropzones:
 ldr r5,tbl_ofs
 ldr r6,active_tile_ofs
 add r5,#(4*4)
 ldr r4,[r6,#(direction-active_tile)]
 mov r6,#gap_right

 ldm r5, {r0-r3}	@     #   #
			@     #   #
 cmp r4,#top_to_bottom	@ #####...#####  =r0
  andeqs r0,#gap_top	@	  .   #  =r1
 mov r0,#0		@	  .   #  =r2
   moveq pc,lr		@	  .   #  =r3
			@	  #####
 cmp r4,#left_to_right	@	  #
  tsteq r1,r6
   tsteq r2,r6
    tsteq r3,r6
     moveq pc,lr

 sub r0,#1
mov pc,lr

tileset:			@ 210
.macro ttile tttile		@ 3x7
 .word \tttile * 0x01010101	@ 456    
.endm				@       
 ttile 0b01100010		@  #
 ttile 0b00110010		@  x     #
 ttile 0b11000010		@  ##    x    #
 ttile 0b10100010		@       ##    x#    #
 ttile 0b11100000		@  x#          #    x#
 ttile 0b00100010		@  ##     #         #
 ttile 0b10100001		@         x    #
 ttile 0		  	@  x      #   ##
tilesn		=(.-tileset)/4	@             #
active_tile_ofs:.word active_tile
add_new_tile:
 push {lr}

 ldr r2,active_tile_ofs
 mov r4,#tilepos2_shift
 mov r5,#tilepos2_ofs

@ get random number
 sub sp,#8
  clr r1
  mov r0,sp
  invoke sys_gettimeofday
 pop {r0,r1}
 eor r0,r0,r1, lsr #5

 ands r3,r0,#left_to_right
  moveq r4,#tilepos1_shift
  orreq r3,#top_to_bottom
  moveq r5,#tilepos1_ofs
 str r3,[r2,#(direction-active_tile)]

@ r2=ofs active_tile
 ldr r6,tbl_ofs
 and r8,r0,#0b110
 adr r7,tileset
 and r0,r0,#(tilesn-1)
 add r5,r6		@ tile ofs
 ldr r1,[r7,r0, lsl #2]	@ load tile from tileset[]

@ r2=ofs active_tile
@ shape=r1 y-ofs=r5, x-shift=r4
 add r6,#(4*4)
 mov r1,r1, ror r8
 mov r7,#gap_top
 stm r2, {r1,r4,r5}

 mov r5,#gap_right
@r6=ofs tbl[]
@r3=direction
@ load 4-7 lines of tbl[]
 ldm r6, {r0,r1,r4,r8}

 cmp r3,#left_to_right
@ clear or set dropzone doors
  orreq r0,r0,r7
  biceq r1,r1,r5
  biceq r4,r4,r5
  biceq r8,r8,r5
  bicne r0,r0,r7
  orrne r1,r1,r5
  orrne r4,r4,r5
  orrne r8,r8,r5
 stm r6, {r0,r1,r4,r8}
pop {pc}

get_ticks:
 push {r1,r7,lr}

 sub sp,#8
  clr r1
  mov r0,sp
  invoke sys_gettimeofday
 pop {r0,r1}

@ r0=sec
@ r1=msec
@ ~1/16 sec precision
 mov r0,r0, lsl #4
 orr r0,r0,r1, lsr #16
pop {r1,r7,pc}

edev_ofs:	.word edev
evdata_ofs:	.word evdata
termios_ofs:	.word termios
fd_tbl_ofs:	.word fd_tbl
tc_gets		=0x5401
tc_puts		=0x5402
keyb_init:
 mov r0,#stdin
 movw r1,#tc_gets
 ldr r2,termios_ofs
 invoke sys_ioctl

 ldmia r2, {r0,r1,r3-r11}
 bic r4,#(isig | iecho | icanon)
 push {r0,r1,r3-r11}
  mov r0,#stdin
  movw r1,#tc_puts
  mov r2,sp
  invoke sys_ioctl
 add sp,#44

 mov r5,#'0'
edev_loop:
 ldr r0,edev_ofs
 mov r1,#(o_rd | o_nonblock)
 strb r5,[r0,#(edevnum-edev)]
 invoke sys_open
 subs r4,r0,#0
movmi pc,lr

@ r0=edev fd
evdata_len=ev_size*4
eviocgname = ioc_read | ((evdata_len-1) << 16) | 0x4506
 movw r1,eviocgname & 0xffff
 ldr r2,evdata_ofs
 movt r1,eviocgname >> 16
 invoke sys_ioctl
@ r0=event name length

 ldr r3,fd_tbl_ofs
 ldr r6,[r2]
 inc r5
  ldr r0,[r3,#0]	@ 1st fd name
   cmp r6,r0
   streq r4,[r3,#0]	@ 1st fd value
   beq edev_loop
  ldr r0,[r3,#4]	@ 2nd fd name
   cmp r6,r0
   streq r4,[r3,#4]	@ 2nd fd value
   beq edev_loop

 mov r0,r4
 invoke sys_close
b edev_loop

keyb_close:
 mov r0,#stdin
 movw r1,#tc_puts
 ldr r2,termios_ofs
 invoke sys_ioctl

 ldr r3,fd_tbl_ofs
 ldr r0,[r3,#0]
 invoke sys_close
 ldr r0,[r3,#4]
 invoke sys_close
mov pc,lr

tbl_ofs:	.word tbl
tblrot_ofs:	.word tblrot
tbl_onscreen:	.word (80*800+400)*2
showtblrot:
 push {r0-r12,lr}

 ldr r4,mmaptbl_ofs
 mov r6,#0x4000		@ x0 << 16, 0.25
 ldr r2,[r4,#(fb_active-mmaptbl)]
 mov r11,#0x48000	@ dv0 4.5
 ldr r3,tblrot_ofs
 mvn r8,r6		@ x1 << 16
 ldr r1,tbl_onscreen
 sub r3,r3,r0,lsl #2

 add r1,r1,r2
 add r3,r3,r0,lsl #5	@ r3=o tblrot[r0*28]

 cmp r0,#(rotdiv/2)
bgt tblrot_o45
 ldm r3!, {r5,r7,r9,r10,r12}
beq tblrot_eq

@ r3[]
@ [0] combined loop1 & 2	=r5
@ [4] x0add			=r7
@ [8] x1add			=r9
@ [0c,10] edge du,dv		=r10,r12
@ [14,18] texel du,dv

5:		@ <45 deg
 bl far_du_const
 add r6,r7
 sub r8,r9
 add r11,r10
 subs r5,#0x10000
 add r1,#1600
bpl 5b

6:
 bl far_du_const
 sub r8,r9
 sub r6,r9
 add r11,r10
 adds r5,#1
 add r1,#1600
bne 6b

 ldr r5,[r3,#(-0x14)]	@ loop1&2
 mov r4,#0x58000	@ du, r10=ddu
7:
 bl far_dv_const
 add r8,r7
 sub r6,r9
 add r4,r12
 subs r5,#0x10000
 add r1,#1600
bpl 7b
pop {r0-r12,pc}

tblrot_eq:		@ 45 deg
 mov r9,r5
1:
 bl far_du_const
 add r6,r7
 sub r8,r7
 add r11,r10
 subs r5,#0x10000
 add r1,#1600
bpl 1b

 mov r4,#0x58000
2:
 bl far_dv_const
 add r8,r7
 sub r6,r7
 add r4,r12
 subs r9,#0x10000
 add r1,#1600
bpl 2b
pop {r0-r12,pc}

tblrot_o45:
 ldr r4,tblrot_ofs
 add r4,#((rotdiv/2)*28)
 rsb r3,r3,r4, lsl #1

 ldm r3!, {r5,r7,r9,r10,r12}
@ r5=		loop1,loop2
@ r8,r6=	x0,x1
@ r7,r9=	x0a,x1a
@ r10,r12=	edge du,dv

 mov r2,r10	@ swap edge/texel du,dv
 ldm r3, {r0,r4}
 mov r10,r12
 str r4,[r3]
 mov r12,r2
 str r0,[r3,#4]

1:
 bl far_du_const
 add r6,r9
 sub r8,r7
 add r11,r10
 subs r5,#0x10000
 add r1,#1600
bpl 1b

 mov r4,#0x58000
2:
 bl far_dv_const
 add r6,r9
 add r8,r9
 add r4,r12
 adds r5,#1
 add r1,#1600
bne 2b

 ldr r5,[r3,#(-0x14)]	@ loop1&2
3:
 bl far_dv_const
 sub r6,r7
 add r8,r9
 add r4,r12
 subs r5,#0x10000
 add r1,#1600
bpl 3b

 ldm r3, {r0,r1}	@ swap texel du,dv
 str r1, [r3],#4
 str r0, [r3]
pop {r0-r12,pc}

far_du_const:
 mov r4,#0x58000
far_dv_const:
 push {r1,r3-r12,lr}

 ldm r3, {r10,r12}

 add r2,r1,r8,asr #15	@ screen offset
 sub r3,r6,r8		@ counter
 bic r2,#1		@ halfword align

 ldr r5,tbl_ofs
@ dv=r11, texel dv=r12
@ du=r4,  texel du=r10
@ r2=screen offset, r3=counter

.if texboard  @ qqq
1:
 mov r0,r11, lsr #16
  movs r1,r11, lsl #16
 sub r11,r12
  rsbmi r1,#0
 ldr r0,[r5,r0, lsl #2]
  movs r14,r4, lsl #16
 mov r7,r4,lsr #16
  rsbmi r14,#0
 add r4,r10
 add r2,#2
 movs r0,r0,lsr r7
 bcc 3f

 cmp r1,#0x10000000
 movw r0,#(0b11101 << 11 | 0b111111 << 5 | 0b11011)
  cmpgt r14,#0x10000000
   strgth r0,[r2,#(-2)]
3:
 subs r3,#0x10000
bpl 1b
.else
1:
 mov r1,r11, lsr #16
 sub r11,r12
 ldr r0,[r5,r1, lsl #2]
 mov r7,r4,lsr #16
 add r4,r10
 add r2,#2 @rrrrrggggggbbbbb
 movw r1,#0b1010011110011000
 movs r0,r0,lsr r7
  strcsh r1,[r2,#(-2)]
 subs r3,#0x10000
bpl 1b
.endif
pop {r1,r3-r12,pc}

blit_y		=81	@ in pixels
blit_x		=200
blit_height	=284
blit_width	=400
blit_ofs:	.word blit_y*1600+blit_x*2
blit_tbl:
 push {r0-r12,lr}

 ldr r1,blit_ofs
 mov r12,#blit_height
 ldr r8,bgdata_ofs
 mov r10,#((800-blit_width)*2)
 ldr r2,mmaptbl_ofs
 add r8,r1	@ src
 ldr r9,[r2,#(fb_active-mmaptbl)]
 add r9,r1	@ dst
9:
 mov r11,#(blit_width*2)
8:
 ldm r8!, {r0-r7}
 subs r11,#32
 stm r9!, {r0-r7}
bne 8b
 subs r12,#1
 add r8,r10
 add r9,r10
bne 9b
pop {r0-r12,pc}

fbio_getvscreeninfo	=0x4600
fbio_putvscreeninfo	=0x4601
fbio_pandisplay		=0x4606
vsync_data:	.word 0
vsync_data_size=.-vsync_data
fb_flip:
 push {r0-r5,lr}

 ldr r3,mmaptbl_ofs
@ wait 4 vsync
vsync_ioctl_command = ioc_write | (4 << 16) | ('F' << 8) | 0x20
@ ldr r1,vsync_ioctl_command
 movw r1,#vsync_ioctl_command & 0xffff
 adr r2,vsync_data
 ldr r0,[r3,#(fhandle-mmaptbl)]
 movt r1,#vsync_ioctl_command >> 16
 invoke sys_ioctl

@ yoffset XOR 480
@ swap fb_active, fb_visible
 ldr r2,fb_var_screeninfo_ofs
 ldr r4,[r3,#(fb_active-mmaptbl)]
 ldr r5,[r3,#(fb_visible-mmaptbl)]
 ldr r0,[r2,#(yoffset-fb_var_screeninfo)]
 movw r1,fbio_pandisplay
 str r4,[r3,#(fb_visible-mmaptbl)]
 eor r0,#480
 str r5,[r3,#(fb_active-mmaptbl)]
 str r0,[r2,#(yoffset-fb_var_screeninfo)]
 ldr r0,[r3,#(fhandle-mmaptbl)]
 invoke sys_ioctl
pop {r0-r5,pc}

@vsync:
@ push {r0-r2,lr}
@ ldr r0,fhandle
@ ldr r1,vsync_ioctl_command
@ adr r2,vsync_data
@ invoke sys_ioctl
@pop {r0-r2,pc}

bgdata_ofs:	.word bgdata
bgsize:		.word 800*480*2
@ mandelbrot params
	mxres	=800
	myres	=480
@ www
	iter	=220
	rstart	=-0x900 @-0x900		@-2.25
	rend	=0x200		@0.75
	istart	=-0x500  @-0x500		@-1.25
	iend	=0x510		@1.25
	rstep	=1 @(rend-rstart)/mxres
	istep	=1 @(iend-istart)/myres
loadbg:
.if mandelback
 ldr r12,bgdata_ofs

 mov r4,#myres
 movw r5,#iend
1:
 mov r3,#mxres
 movw r6,#rend
2:
 mov r8,r5
 mov r7,r6
 mov r9,#iter
3:
 mul r10,r7,r7
 mul r11,r8,r8
 mul r0,r7,r8

 add r1,r10,r11
 sub r7,r10,r11
  subs r9,#1
 add r8,r5,r0, asr #(10-1)
  cmpne r1,#(4 << 20)
 add r7,r6,r7, asr #10
  blt 3b

 movw r1,#0b0001000000100001
 mul r1,r9
 strh r1,[r12],#2

 subs r3,#1
 sub r6,#rstep
bne 2b
 subs r4,#1
 sub r5,#istep
bne 1b

.else
 adr r0,bgname
 mov r1,#o_rd
 invoke sys_open
 sub r4,r0,#0
bpl loadbg1
 deb "background.img is missing"

 mov r0,#0
 ldr r4,bgdata_ofs
 ldr r5,bgsize
 mov r1,r0
terminator:
 subs r5,#8
 stm r4!, {r0,r1}
bne terminator
b loadbg2

bgname:	.asciz "background.img"
	.align
loadbg1:
 ldr r1,bgdata_ofs
 ldr r2,bgsize
 invoke sys_read
 mov r0,r4
 invoke sys_close
loadbg2:
.endif

@
@ clr background
@ fill fbp[] with 0's
 ldr r2,mmaptbl_ofs
 clr r0
 clr r1
 ldr r3,[r2,#(fbp-mmaptbl)]
 mov r5,r0
 mov r6,r0
 ldr r4,[r2,#(screensize-mmaptbl)]
11:
 subs r4,#16
 stm r3!, {r0,r1,r5,r6}
bne 11b
@

@
@ copy background image to fb pages 0 and 1
 ldr r2,mmaptbl_ofs
 ldr r10,bgsize
 ldr r12,bgdata_ofs
 ldr r11,[r2,#(fb_visible-mmaptbl)]
 ldr r9,[r2,#(fb_active-mmaptbl)]
hellraiser:
 ldm r12!, {r0-r7}
 subs r10,#32
 stm r11!, {r0-r7}
 stm r9!, {r0-r7}
bne hellraiser
mov pc,lr

fbinit:
 adr r0,fbdev
 mov r1,#o_rdwr
 invoke sys_open
 ldr r6,mmaptbl_ofs
 cmp r0,#0
bpl open1
 deb "can not open fbdev"
 mvn r0,#0
mov pc,lr
fb_var_screeninfo_ofs:
		.word fb_var_screeninfo
mmaptbl_ofs:	.word mmaptbl
fbdev:		.asciz "/dev/fb0"
		.align
open1:
 str r0,[r6,#(fhandle-mmaptbl)]
 movw r1,#fbio_getvscreeninfo
 ldr r2,fb_var_screeninfo_ofs
 invoke sys_ioctl
 cmn r0,#0
bpl ioctl1
ioctl0:
 deb "can not ioctl or mmap fb"

 ldr r0,[r6,#(fhandle-mmaptbl)]
 invoke sys_close

 mvn r0,#0
mov pc,lr

ioctl1:
@ setup double-buffering
 ldr r0,[r2,#(yres-fb_var_screeninfo)]
 mov r3,r0,lsl #1
 ldr r0,[r6,#(fhandle-mmaptbl)]
 movw r1,#fbio_putvscreeninfo
 str r3,[r2,#(yres_virtual-fb_var_screeninfo)]
 invoke sys_ioctl
 cmn r0,#0
bmi ioctl0

@ calculate screensize
@ r3=yres_virtual
 ldr r0,[r2,#(xres-fb_var_screeninfo)]
 mul r1,r0,r3
 ldr r0,[r2,#(bpp-fb_var_screeninfo)]
 mul r1,r0,r1
 mov r0,r1, lsr #3
 str r0,[r6,#(screensize-mmaptbl)]

@ mmap fb
@ r6=o mmaptbl
 ldmia r6, {r0-r5}
 push {r4,r5}
 invoke sys_mmap2
 cmp r0,#0
 add sp,#8
ble ioctl0

 ldr r1,[r6,#(screensize-mmaptbl)]
 str r0,[r6,#(fbp-mmaptbl)]
 add r1,r0,r1, lsr #1
 str r0,[r6,#(fb_visible-mmaptbl)]
 str r1,[r6,#(fb_active-mmaptbl)]
mov pc,lr

fbclose:
@ pan to page 0
 ldr r2,fb_var_screeninfo_ofs
 clr r3
 ldr r6,mmaptbl_ofs
 str r3,[r2,#(yoffset-fb_var_screeninfo)]
 movw r1,fbio_pandisplay
 ldr r0,[r6,#(fhandle-mmaptbl)]
 invoke sys_ioctl

@ unmap fbdev
 ldr r0,[r6,#(fbp-mmaptbl)]
 ldr r1,[r6,#(screensize-mmaptbl)]
 invoke sys_munmap

@ close fbdev
 ldr r0,[r6,#(fhandle-mmaptbl)]
 invoke sys_close
mov pc,lr

fontset_ofs: .word fontset
blit_txt_ofs:.word blit_txt
putch:
@ r0=char, r1=screenofs
 cmp r0,#' '
  addeq r1,#(5*4)
  moveq pc,lr

 push {r0-r7,lr}

 cmp r0,#'a'
  addlt r0,#('z'-'0'+1-'a')
  subge r0,#'a'
 ldr r3,fontset_ofs
 and r2,r0,#0b111
 bic r0,#0b111
 mov r2,r2, lsl #2
 ldr r6,blit_txt_ofs
 add r0,r0, lsl #2
 mov r5,#1
 add r3,r0, lsr #1
 add r1,r6
 mov r4,#5
 mov r5,r5, lsl r2

 mvn r6,#0		@ color
@ r1=screenofs

11:
 ldr r0,[r3],#4
 mov r2,#4
22:
 tst r0,r5
 beq 222f
  mov r7,#4
  33:
   str r6,[r1]
   str r6,[r1,#4]
   add r1,#1600
  regloop r7,33b
  sub r1,#(4*1600)
222:
 add r1,#8
 mov r5,r5, ror #31
regloop r2,22b
 sub r1,#(4*8)
 mov r5,r5, ror #4
 add r1,#(4*1600)
regloop r4,11b
pop {r0-r7,pc}

help_base	=8*2
help_stri:
@ 	help screen - menu
	.byte ' ',' ',' ',1		@ set screenofs
	.word help_base
	.ascii "up;down:choose menu  b:select"
@	help screen - in game
	.byte ' ',' ',1	@ set screen offset
	.word help_base+1600*6*4
	.ascii "left;right:move" @  score:0123456789"
	.byte 1
	.word help_base+1600*6*4*2
	.ascii "y:rotate  down:drop  x:pause;exit"
@ 	help screen - paused
	.byte ' ',' ',1		@ set screenofs
	.word help_base + 1600*3*6*4
	.ascii "x:exit  y:resume game"
	.byte 0
	.align

prep_txt:
 push {lr}

 adr r2,help_stri
3:
 ldrb r0,[r2],#1
 cmp r0,#0
beq 4f
 cmp r0,#1
  ldreq r1,[r2],#4
  beq 3b
 bl putch
 add r1,#(5*4*2)
b 3b
4:
pop {pc}

.data

snd_effect:	.asciz "boing.raw"
		.align
dev_dsp:	.asciz "/dev/dsp"
		.align
@---------------------

.include 	"fontset.inc"	@ fontset[]
@---------------------

active_tile:	.word 0	@ shape
		.word 0 @ y-offset
		.word 0 @ x-shift
balance:	.word 16
balance_cur: 	.word 16
direction:	.word 0
leave_block:	.word 0
@---------------------

edev:	.ascii "/dev/input/event"
edevnum:.byte 0,0
edev_len=.-edev-1
	.align
@---------------------

fd_tbl:	.ascii "keyp"  @ 'keypad'
	.ascii "gpio"  @ 'gpio_keys'
@---------------------

mmaptbl:
fbp:		.word -1
screensize:	.word -1
		.word prot_read | prot_write
		.word map_shared
fhandle:	.word -1
		.word 0
fb_active:	.word -1
fb_visible:	.word -1
@---------------------

tblrot:	.include "tblrot.inc"
@---------------------

tbl:
.word 0b00000000111110000
.rept 3
.word 0b00000000100010000
.endr
.word 0b11111111111111111
.rept 3
.word 0b10000000000010001
.endr
.word 0b10000000000011111
.rept 7
.word 0b10000000000010000
.endr
.word 0b11111111111110000

@score:		.word 0
@---------------------

.macro menu_entry ppar1, ppar2, ppar3
 .word \ppar1	@ image offset
 .word \ppar2	@ image scroll width
 .word \ppar3	@ branch adress
.endm

img_new_game:
 .word 0b00011101010111011000101011100110
 .word 0b00000101110101000100101000101010
 .word 0b00011101010111010100101011101010
 .word 0b00000101010101010100111000101010
 .word 0b00011101010101011000101011101010

img_exit:
 .word 0b00000000000000000011101010101110
 .word 0b00000000000000000001001010100010
 .word 0b00000000000000000001001001000110
 .word 0b00000000000000000001001010100010
 .word 0b00000000000000000001001010101110

menu2	=0
.if (menu2==1)
img_continue:
@          eee uuu nnn i ttt nnn ooo ccc
 .word 0b00111010100110101110011001001100
 .word 0b00001010101010100100101010100010
 .word 0b00111010101010100100101010100010
 .word 0b00001010101010100100101010100010
 .word 0b00111011001010100100101001001100

img_help:
@                        ppp lll eee hhh
 .word 0b00000000000000000110001011101010
 .word 0b00000000000000001010001000101010
 .word 0b00000000000000001110001011101110
 .word 0b00000000000000000010001000101010
 .word 0b00000000000000000010111011101010
.endif

menu_selected:	.word 0	  @ active menu #
		.word 0   @ scroll position
		.word 1   @ scroll direction 1,(-1)
menu:
	menu_entry img_new_game, 30-11, me_newgame
menu_entry_siz	=.-menu
@	menu_entry img_continue, 32-11, exit_game
@	menu_entry img_help, 17-11, exit_game
	menu_entry img_exit, 15-11, exit_game
menu_items=(.-menu)/menu_entry_siz

.align 4

.bss

sound_buf:	.fill sound_buf_size,1,0

evdata:
 .fill evdata_len,1,0

termios:
 .word 0,0,0,0
 .fill 20,1,0
 .word 0,0,0,0

fb_var_screeninfo:
 xres: 		.word 0
 yres: 		.word 0
 xres_virtual:  .word 0
 yres_virtual:  .word 0
 xoffset: 	.word 0
 yoffset: 	.word 0
 bpp: 		.word 0
 grayscale: 	.word 0
	 @ fb_bitfield struc
	 @  offset:    .word 0
	 @  length:    .word 0
	 @  msb_right: .word 0
	 @ ends
 bitfield_red:   .word 0,0,0
 bitfield_green: .word 0,0,0
 bitfield_blue:  .word 0,0,0
 bitfield_transp:.word 0,0,0
 nonstd: 	.word 0
 activate: 	.word 0
 height: 	.word 0
 width: 	.word 0
 accel_flags:   .word 0
 pixclock: 	.word 0
 left_margin:   .word 0
 right_margin:  .word 0
 upper_margin:  .word 0
 lower_margin:  .word 0
 hsync_len: 	.word 0
 vsync_len: 	.word 0
 sync: 		.word 0
 vmode: 	.word 0
 rotate: 	.word 0
 colorspace: 	.word 0
 .fill 4,4,-1 	@reserved

bgdata:		.fill 800*480,2,0

blit_txt:	.fill 800*4*6*4,2,0

.align 4

.end
